class YoloXWrapper(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  num_classes : int
  nms_threshold : float
  model : __torch__.yolox.models.yolox.YOLOX
  def forward(self: __torch__.YoloXWrapper,
    x: Tensor,
    ids: Optional[Tensor]=None,
    bboxes: Optional[Tensor]=None,
    labels: Optional[Tensor]=None) -> Tuple[Dict[str, Tensor], List[Dict[str, Tensor]]]:
    _0 = __torch__.yolox.utils.boxes.postprocess
    _1 = uninitialized(Tensor)
    _2 = ops.prim.device(x)
    _3 = torch.zeros([0, 4], dtype=None, layout=None, device=_2)
    _4 = ops.prim.device(x)
    _5 = torch.zeros([0], dtype=None, layout=None, device=_4)
    _6 = ops.prim.device(x)
    _7 = torch.zeros([0], dtype=4, layout=None, device=_6)
    placeholder = {"boxes": _3, "scores": _5, "labels": _7}
    training = self.training
    if training:
      if torch.__isnot__(ids, None):
        ids0 = unchecked_cast(Tensor, ids)
      else:
        ops.prim.RaiseException("AssertionError: ")
        ids0 = _1
      if torch.__isnot__(bboxes, None):
        bboxes0 = unchecked_cast(Tensor, bboxes)
      else:
        ops.prim.RaiseException("AssertionError: ")
        bboxes0 = _1
      if torch.__isnot__(labels, None):
        labels0 = unchecked_cast(Tensor, labels)
      else:
        ops.prim.RaiseException("AssertionError: ")
        labels0 = _1
      _8 = annotate(List[Tensor], [])
      max_count = 0
      stop = 0
      for i in range((torch.size(x))[0]):
        _9 = torch.lt(stop, (torch.size(ids0))[0])
        if _9:
          _11 = torch.eq(torch.select(ids0, 0, stop), i)
          _10 = bool(_11)
        else:
          _10 = False
        stop0 = stop
        _12 = _10
        while _12:
          stop1 = torch.add(stop0, 1)
          _13 = torch.lt(stop1, (torch.size(ids0))[0])
          if _13:
            _15 = torch.select(ids0, 0, stop1)
            _14 = bool(torch.eq(_15, i))
          else:
            _14 = False
          _12, stop0 = _14, stop1
        _16 = torch.slice(labels0, 0, stop, stop0)
        _17 = torch.sub(torch.unsqueeze(_16, 1), 1)
        _18 = torch.slice(bboxes0, 0, stop, stop0)
        _19 = [_17, (self).convert_targs(_18, )]
        targ = torch.cat(_19, 1)
        _20 = torch.append(_8, targ)
        max_count0 = ops.prim.max(max_count, (torch.size(targ))[0])
        max_count, stop = max_count0, stop0
      l_targs = annotate(List[Tensor], [])
      for _21 in range(torch.len(_8)):
        targ0 = _8[_21]
        _22 = torch.sub(max_count, (torch.size(targ0))[0])
        _23 = torch.pad(targ0, [0, 0, 0, _22])
        _24 = torch.append(l_targs, _23)
      targs = torch.stack(l_targs)
      model = self.model
      output, losses0, = (model).forward(x, targs, )
      losses, preds = losses0, [placeholder]
    else:
      losses1 = annotate(Dict[str, Tensor], {})
      _25 = __torch__.torch.autograd.grad_mode.no_grad.__new__(__torch__.torch.autograd.grad_mode.no_grad)
      _26 = (_25).__init__()
      with _25:
        model0 = self.model
        output0 = ((model0).forward(x, None, ))[0]
        num_classes = self.num_classes
        nms_threshold = self.nms_threshold
        preds_list = _0(output0, num_classes, 0.01, nms_threshold, False, )
      preds0 = torch.slice([placeholder], 1)
      for _27 in range(torch.len(preds_list)):
        pred = preds_list[_27]
        _28 = torch.eq((torch.size(pred))[0], 0)
        if _28:
          _29 = torch.append(preds0, placeholder)
        else:
          _30 = torch.slice(torch.slice(pred), 1, None, 4)
          _31 = torch.select(torch.slice(pred), 1, 4)
          _32 = torch.select(torch.slice(pred), 1, 5)
          _33 = torch.mul(_31, _32)
          _34 = torch.select(torch.slice(pred), 1, 6)
          _35 = torch.add(torch.to(_34, 4), 1)
          _36 = {"boxes": _30, "scores": _33, "labels": _35}
          _37 = torch.append(preds0, _36)
      losses, preds = losses1, preds0
    return (losses, preds)
  def convert_targs(self: __torch__.YoloXWrapper,
    bboxes: Tensor) -> Tensor:
    yolox_boxes = torch.new_zeros(bboxes, torch.size(bboxes))
    _38 = torch.select(torch.slice(bboxes), 1, 0)
    _39 = torch.select(torch.slice(bboxes), 1, 2)
    _40 = torch.div(torch.add(_38, _39), 2)
    _41 = torch.select(torch.slice(yolox_boxes), 1, 0)
    _42 = torch.copy_(_41, _40)
    _43 = torch.select(torch.slice(bboxes), 1, 1)
    _44 = torch.select(torch.slice(bboxes), 1, 3)
    _45 = torch.div(torch.add(_43, _44), 2)
    _46 = torch.select(torch.slice(yolox_boxes), 1, 1)
    _47 = torch.copy_(_46, _45)
    _48 = torch.select(torch.slice(bboxes), 1, 2)
    _49 = torch.select(torch.slice(bboxes), 1, 0)
    _50 = torch.sub(_48, _49)
    _51 = torch.select(torch.slice(yolox_boxes), 1, 2)
    _52 = torch.copy_(_51, _50)
    _53 = torch.select(torch.slice(bboxes), 1, 3)
    _54 = torch.select(torch.slice(bboxes), 1, 1)
    _55 = torch.sub(_53, _54)
    _56 = torch.select(torch.slice(yolox_boxes), 1, 3)
    _57 = torch.copy_(_56, _55)
    return yolox_boxes
