class L1Loss(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : NoneType
  reduction : Final[str] = "none"
  def forward(self: __torch__.torch.nn.modules.loss.L1Loss,
    input: Tensor,
    target: Tensor) -> Tensor:
    _0 = __torch__.torch.nn.functional.l1_loss
    _1 = _0(input, target, None, None, "none", )
    return _1
class BCEWithLogitsLoss(Module):
  __parameters__ = []
  __buffers__ = ["weight", "pos_weight", ]
  weight : NoneType
  pos_weight : NoneType
  training : bool
  _is_full_backward_hook : NoneType
  reduction : str
  def forward(self: __torch__.torch.nn.modules.loss.BCEWithLogitsLoss,
    input: Tensor,
    target: Tensor) -> Tensor:
    _2 = __torch__.torch.nn.functional.binary_cross_entropy_with_logits
    weight = self.weight
    pos_weight = self.pos_weight
    reduction = self.reduction
    _3 = _2(input, target, weight, None, None, reduction, pos_weight, )
    return _3
