class CSPLayer(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  conv1 : __torch__.yolox.models.network_blocks.___torch_mangle_16.BaseConv
  conv2 : __torch__.yolox.models.network_blocks.___torch_mangle_16.BaseConv
  conv3 : __torch__.yolox.models.network_blocks.___torch_mangle_18.BaseConv
  m : __torch__.torch.nn.modules.container.___torch_mangle_22.Sequential
  def forward(self: __torch__.yolox.models.network_blocks.___torch_mangle_23.CSPLayer,
    x: Tensor) -> Tensor:
    conv1 = self.conv1
    x_1 = (conv1).forward(x, )
    conv2 = self.conv2
    x_2 = (conv2).forward(x, )
    m = self.m
    x_10 = (m).forward(x_1, )
    x0 = torch.cat([x_10, x_2], 1)
    conv3 = self.conv3
    return (conv3).forward(x0, )
