class YOLOX(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  backbone : __torch__.yolox.models.yolo_pafpn.YOLOPAFPN
  head : __torch__.yolox.models.yolo_head.YOLOXHead
  def forward(self: __torch__.yolox.models.yolox.YOLOX,
    x: Tensor,
    targets: Optional[Tensor]=None) -> Tuple[Tensor, Dict[str, Tensor]]:
    _0 = uninitialized(Tensor)
    backbone = self.backbone
    fpn_outs = (backbone).forward(x, )
    training = self.training
    if training:
      if torch.__isnot__(targets, None):
        targets0 = unchecked_cast(Tensor, targets)
      else:
        ops.prim.RaiseException("AssertionError: ")
        targets0 = _0
      head = self.head
      _1 = (head).forward(fpn_outs, targets0, x, )
      outputs0, _2, = _1
      loss0, iou_loss0, conf_loss0, cls_loss0, l1_loss0, num_fg0, = _2
      num_fg, loss, iou_loss, l1_loss, conf_loss, cls_loss, outputs = num_fg0, loss0, iou_loss0, l1_loss0, conf_loss0, cls_loss0, outputs0
    else:
      head0 = self.head
      _3 = (head0).forward(fpn_outs, CONSTANTS.c0, CONSTANTS.c0, )
      outputs1, _4, = _3
      loss1, iou_loss1, conf_loss1, cls_loss1, l1_loss1, num_fg1, = _4
      num_fg, loss, iou_loss, l1_loss, conf_loss, cls_loss, outputs = num_fg1, loss1, iou_loss1, l1_loss1, conf_loss1, cls_loss1, outputs1
    losses = {"total_loss": loss, "iou_loss": iou_loss, "l1_loss": l1_loss, "conf_loss": conf_loss, "cls_loss": cls_loss, "num_fg": torch.tensor([num_fg])}
    return (outputs, losses)
