class IOUloss(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  reduction : str
  loss_type : str
  def forward(self: __torch__.yolox.models.losses.IOUloss,
    pred: Tensor,
    target: Tensor) -> Tensor:
    _0 = torch.eq((torch.size(pred))[0], (torch.size(target))[0])
    if _0:
      pass
    else:
      ops.prim.RaiseException("AssertionError: ")
    pred0 = torch.view(pred, [-1, 4])
    target0 = torch.view(target, [-1, 4])
    _1 = torch.slice(torch.slice(pred0), 1, None, 2)
    _2 = torch.slice(torch.slice(pred0), 1, 2)
    _3 = torch.sub(_1, torch.div(_2, 2))
    _4 = torch.slice(torch.slice(target0), 1, None, 2)
    _5 = torch.slice(torch.slice(target0), 1, 2)
    tl = torch.max(_3, torch.sub(_4, torch.div(_5, 2)))
    _6 = torch.slice(torch.slice(pred0), 1, None, 2)
    _7 = torch.slice(torch.slice(pred0), 1, 2)
    _8 = torch.add(_6, torch.div(_7, 2))
    _9 = torch.slice(torch.slice(target0), 1, None, 2)
    _10 = torch.slice(torch.slice(target0), 1, 2)
    br = torch.min(_8, torch.add(_9, torch.div(_10, 2)))
    _11 = torch.slice(torch.slice(pred0), 1, 2)
    area_p = torch.prod(_11, 1)
    _12 = torch.slice(torch.slice(target0), 1, 2)
    area_g = torch.prod(_12, 1)
    _13 = torch.to(torch.lt(tl, br), torch.to(tl))
    en = torch.prod(_13, 1)
    area_i = torch.mul(torch.prod(torch.sub(br, tl), 1), en)
    area_u = torch.sub(torch.add(area_p, area_g), area_i)
    _14 = torch.add(area_u, 9.9999999999999998e-17)
    iou = torch.div(area_i, _14)
    loss = torch.full([1], 0)
    loss_type = self.loss_type
    if torch.eq(loss_type, "iou"):
      loss1 = torch.add(torch.neg(torch.pow(iou, 2)), 1)
      loss0 = loss1
    else:
      loss_type0 = self.loss_type
      if torch.eq(loss_type0, "giou"):
        _15 = torch.slice(torch.slice(pred0), 1, None, 2)
        _16 = torch.slice(torch.slice(pred0), 1, 2)
        _17 = torch.sub(_15, torch.div(_16, 2))
        _18 = torch.slice(torch.slice(target0), 1, None, 2)
        _19 = torch.slice(torch.slice(target0), 1, 2)
        _20 = torch.sub(_18, torch.div(_19, 2))
        c_tl = torch.min(_17, _20)
        _21 = torch.slice(torch.slice(pred0), 1, None, 2)
        _22 = torch.slice(torch.slice(pred0), 1, 2)
        _23 = torch.add(_21, torch.div(_22, 2))
        _24 = torch.slice(torch.slice(target0), 1, None, 2)
        _25 = torch.slice(torch.slice(target0), 1, 2)
        _26 = torch.add(_24, torch.div(_25, 2))
        c_br = torch.max(_23, _26)
        area_c = torch.prod(torch.sub(c_br, c_tl), 1)
        _27 = torch.sub(area_c, area_u)
        _28 = torch.clamp(area_c, 9.9999999999999998e-17)
        giou = torch.sub(iou, torch.div(_27, _28))
        _29 = torch.neg(torch.clamp(giou, -1., 1.))
        loss2 = torch.add(_29, 1)
      else:
        loss2 = loss
      loss0 = loss2
    reduction = self.reduction
    if torch.eq(reduction, "mean"):
      loss3 = torch.mean(loss0)
    else:
      reduction0 = self.reduction
      if torch.eq(reduction0, "sum"):
        loss4 = torch.sum(loss0)
      else:
        loss4 = loss0
      loss3 = loss4
    return loss3
